# This is a -*- perl -*- script, but it isn't directly runnable.
# Say "perl scriptname" instead.
#
# 'findold' finds old versions that may be removed.

$prefix='/store' ;

unshift( @INC, "$prefix/etc/internal" ) ;
unshift( @INC, "." ) ;

require "lib/client.pl" ;
require "lib/conffile.pl" ;
require "lib/config.pl" ;
require "lib/ficcl.pl" ;
require "lib/genarchs.pl" ;
require "lib/indata.pl" ;
require "lib/master.pl" ;
require "lib/output.pl" ;
require "lib/regist.pl" ;
require "lib/registerit.pl" ;
require "lib/runit.pl" ;
require "lib/shadowit.pl" ;
require "lib/slaveit.pl" ;
require "lib/support.pl" ;
require "lib/utils.pl" ;

&'readgenarchs ;
&'readconffile("$config") ;

$'myself = &mymachine() ;

$'debug = $'WARNINGS | $'INFO ;
$'debug = $'WARNINGS | $'INFO | $'TRACE if (-t) ;

# Setup finished

# Main program.

# Options:
# -a app
# -s store
# -v version

$err = 0;
$donemst = $doneapp = 0 ;

# parse options

while ( $_ = $ARGV[0] ) {
   shift;
   $err=1, last if /^-../ ;
   if (/^-m/)  { $master = shift ; $donemst = 1 ; next ; }
   if (/^-a/)  { $applica = shift ; $doneapp = 1 ; next ; }
   $err=1; last ;
}

if ( $err ) {
   print "Usage: findold [ -m master [ -a application ] ]\n" ;
   exit 1;
}

if ( $donemst ) {
    &'output('Fatal',"Unknown store\n",'',$master),exit 1
	unless $'isaknownstore{$master} ;
    @myservers = ( $master );
} else {
    @allstores = &getstorelist ;
    @myservers = grep( $'master{$_} eq $'myself , @allstores ) ;
    @myservers = &'uniq( @myservers ) ;
}

if ( $doneapp ) {
    &'output('Fatal',"No master store specified, but application specified\n"),exit 1
	unless (  $donemst );
    @applist = ( $applica );
}

for $store ( @myservers ) {

    @applist = &'getmastapplist($store) unless ( $doneapp );

    for $appl ( @applist ) {
	
	&'readregist( $store, $appl) ;
	&'multi_version_parse() ;
	
	@versions = sort keys %'origmultisupport;
	$normalsupp='';
	
	for $ver ( @versions ) {
	    # Get support for release and stable.
	    if ( ( $'releaselevel{$ver} eq 'release' ) || 
		( $'releaselevel{$ver} eq 'stable' ) ||
		( $'releaselevel{$ver} eq 'dated' ) ) {
		$normalsupp = &'genintersect( $normalsupp . '/' . $origmultisupport{$ver} );
	    }
	}

	if ( $normalsupp eq '' ) {
	    &'output('Warning',"NO normal support for $appl\n",'',$store,$appl);
	    next;
	}

	for $ver ( @versions ) {
	    if ( ( $'releaselevel{$ver} eq 'old' ) || ( $'releaselevel{$ver} eq 'obsolete' ) ) {
		$versupp = $origmultisupport{$ver} ;
		$needsupp = &'genintersect( $versupp ,  "!/$normalsupp" );
		$noneedsupp = &'genintersect( $versupp, $normalsupp );
		if ( $needsupp eq '') {
		    &output('Info',"Can be removed\n",'',
			    $store,$appl,$ver);
		}
		if ( $noneedsupp ne '' && $needsupp ne '' ) {
		    $pretty = &'nicesupp($noneedsupp);
		    &'output('Info',"Can remove support for $pretty\n",'',
			     $store,$appl,$ver);
		    $pretty = &'nicesupp($needsupp);
		    &'output('Info',"Should keep support for $pretty\n",'',
			     $store,$appl,$ver);
		    
		}
	    }
	}
    }
}
