# This is a -*- perl -*- script, but it isn't directly runnable.
# Say "perl scriptname" instead.

$storeuid = getpwnam( 'store' ) ;
die "(MIME) Only runnable by store user!\n" if ($< != $storeuid) ;

$TOP = $ENV{TOPDIR} || '/store';

&make_mailcap( "$TOP/etc" );

sub make_mailcap {
    local( $dir ) = @_;
    return unless -d $dir;
    chdir $dir;

    %mc_content = &read_mailcapfile( "$dir/mailcap" );

    unlink ("mailcap.old");
    rename ("mailcap", "mailcap.old");
    unlink ("mailcap");
    open(DEFOUT, ">mailcap");
    chmod(0644, "mailcap");
    
    $op = "(MIME) Making $dir/mailcap\n" ;

    &get_mailcaps( "$TOP/etc/mailcaps" );

    foreach $content ( sort keys %fields ) {
	$cname = $content; $cname =~ tr/\~/\*/;
	undef @lines; undef %incfrom;
	foreach $field ( sort split(/;/, $fields{$content}) ) {
	    $incfrom{$from{$content,$field}} = 1;
	    if ( $field eq '*' ) { 
		push( @lines, "$entry{$content,$field}" );
	    } else {
		push( @lines, "$field=$entry{$content,$field}" );
	    }
	}
	$content = join("; \\\n\t", @lines);
	print DEFOUT ( "$cname; $content\n" );
	$op .= ("(MIME) Include $cname from " .
		join( ',', sort keys %incfrom ) . "\n")
	    if $content ne $mc_content{$cname};
    }
    close(DEFOUT) ;

    if ( -r "mailcap.old" ) {
	$op .= "(MIME) differences:\n";
	$di  = `diff -rc mailcap.old mailcap`;
	$op .= $di;
	$op .= "(MIME) End $dir/mailcap\n";
    
	print $op unless (( $di =~ /No differences/ ) || ( $di eq "" ));
    }
    
    unlink ("mailcap.old");
}

sub read_mailcapfile {
    local( $mcap ) = @_;
    local( %mc_content, $content );
    return unless -r $mcap;

    open( MAILCAP, $mcap ) || die "(MIME) Unable to open $mcap: $!\n";
    while ( <MAILCAP> ) {
	next if /^\#/;
	next if /^\s*$/;
	$_ .= <MAILCAP> while /\\$/;
	chop;
	( $content ) = /^([^;]+);/;
	s/^[^;]+;\s*//;
	$mc_content{$content} = $_;
    }	
    close MAILCAP;

    %mc_content;
}

sub get_mailcaps {
    local( $dir ) = @_;
    return unless -d $dir;

    @files = <$dir/mailcap-*>;
    for ( @files ) {
	( $name, $pri ) = /mailcap-(.*)-(\d+)$/;
        open( MCAP, $_ );
	while ( <MCAP> ) {
	    next if /^\#/;
	    next if /^\s*$/;
	    $_ .= <MCAP> while /\\$/;
	    chop;
	    ( $content ) = /^([^;]+);/;
	    $content =~ tr/\*/\~/; # So that it sorts nicely

	    s/^[^;]+;\s*//;       # Remove content-type
	    s/([^\\]);/\1;;/g;    # So that we may split it on ;;

	    foreach $field ( split( /;;/ ) ) {
		$field =~ s/[ \t\n\\]*//;
		if ( $field =~ /^\s*\w+\s*=/ ) {
		    ( $fname, $fval ) = $field =~ /^\s*(\w+)\s*=\s*([^\0]+)$/;
		} else {
		    ( $fname, $fval ) = ( '*', $field );
		}
		if ( !$pri{$content,$fname} ) {
		    if ( $fields{$content} ) { $fields{$content}.=";$fname"; }
		    else { $fields{$content} = $fname; }
		}
		if (!$pri{$content,$fname} || $pri{$content,$fname} > $pri) {
		    $pri{$content,$fname} = $pri;
		    $entry{$content,$fname} = $fval;
		    $from{$content,$fname} = $name;
		}
	    }
	}
	close MCAP;
    }

}
