# This is a -*- perl -*- script, but it isn't directly runnable.
# Say "perl scriptname" instead.
#
# 'news' updates enries in the /store/news directory.

$prefix='/store' ;

unshift( @INC, "$prefix/etc/internal" ) ;
unshift( @INC, "." ) ;

require "lib/client.pl" ;
require "lib/conffile.pl" ;
require "lib/config.pl" ;
require "lib/genarchs.pl" ;
require "lib/indata.pl" ;
require "lib/master.pl" ;
require "lib/output.pl" ;
require "lib/regist.pl" ;
require "lib/registerit.pl" ;
require "lib/runit.pl" ;
require "lib/shadowit.pl" ;
require "lib/slaveit.pl" ;
require "lib/support.pl" ;
require "lib/utils.pl" ;
require "lib/notlinks.pl" ;

&'readgenarchs ;
&'readconffile("$config") ;

$'myself = &mymachine() ;

$'debug = $'WARNINGS | $'INFO ;
$'debug = $'WARNINGS | $'INFO | $'TRACE if (-t) ;

# Setup finished

# subroutine that returns the names of all directory entries
# in a dir except . and ..
# should probably move to utils.pl
sub 'getAdir
{
	local ( $dn ) = @_ ;
	local ( @dl, @ra, *TD ) ;

	opendir(TD, "$dn") ;
	@dl = readdir(TD) ;
	closedir(TD) ;
	@ra = ( ) ;
	for (@dl) {
		next if ($_ eq ".") ;
		next if ($_ eq "..") ;
		push(@ra, $_) ;
	}
	return @ra ;
}

	
@linktrees = ( @ARGV ) ? ( @ARGV ) :
             ( grep( $'hostnm{$_} =~ /^$'myself$/, keys %'hostnm )) ;

&'output('Trace', "Running for '@linktrees'\n");

#
# Check all linktrees
#
for $linktree (@linktrees)
{
    die "Internal error in news: Linktree '$linktree' is unknown.\n"
	unless ( $'isalinktree{$linktree} );

    $top = $topdir{$linktree};
    mkdir("$top/news", 0755) unless -d "$top/news";

    #
    # Check all applications within linktree
    #
    for $appl ( &getAdir("$top/etc/appinfo") ) {
	next unless ($st, $ver, $path) = 
	    &client'linkedupapp( $linktree, $appl );
	$islinkedup{$appl} = 1;

	if ( -f "$top/news/$appl" ) {
	    open (NEWS, "$top/news/$appl") ||
		die "Unable to open '.../news/$appl': $!\n";
	    $_ = <NEWS>;
	    close NEWS;
	    ($oldver) = /^-- \S+ version (\S+) --$/;

	    # Check if newsfile needs update
	    next if $oldver eq $ver;
	    &'output('Info', "Updating newsfile\n", '', $st, $appl, $ver );

	} else {
	    &'output('Info', "Creating newsfile\n", '', $st, $appl, $ver );
	    push( @newnotlinks, 'perl-internal', 'news/.*', "news/$appl" ) ;
	}

	$appldir = ".$appl";
	$appldir = $appl if ( -d "$'storedir{$st}/$appl" );
	&'readregist( $st, $appldir );

	## Find description
	$description = $'regist{'sec_description'};
	$description = $'regist{'descr'}."\n" unless $description =~ /\S/;
	$description = "Installed.\n" unless $description =~ /\S/;

	## Get uid of user who installed the package
	$username = ''; $uid = -1;
	if ($'regist{'sec_log'}) {	
	    $username = $1 
		while ( $'regist{'sec_log'} =~ /\ngetlogin=(\w+),/g );
	    $uid = ( getpwnam($username) )[2] if $username;
	}

	## Write newsfile
	unlink("$top/news/$appl");
	open (NEWS, ">$top/news/$appl") ||
	    die "Unable to write '.../news/$appl': $!\n";
	print NEWS "-- $appl version $ver --\n$description";
	close NEWS;
	chown $uid, $), "$top/news/$appl" if $uid != -1;
    }

    # Merge new newsfiles into notlinks-file
    &mergenotlinks( $linktree, @newnotlinks ) if @newnotlinks ;

    #
    # Delete newsfiles for applications that are not linked up
    #
    for $appl ( &getAdir("$top/news") ) {
	next if $islinkedup{$appl};
	&'output('Info', "Removing newsfile\n", '', '', $appl );
	unlink( "$top/news/$appl" );
	push( @remnotlinks, "news/$appl" ) ;
    }

    # Remove deleted newsfiles from notlinks-file
    &removenotlinks( $linktree, @remnotlinks ) if @remnotlinks ;
}
