#!/bin/sh
#
# Author: Petter Reinholdtsen <pere@td.org.uit.no>
#
# Run store-extra nightly jobs.

PERL=perl

if test -z "$TOPDIR"; then
  echo "TOPDIR not set!  Exiting"
  exit 1
fi

#
# Chekc libtool libraries for alternative names
#
$PERL $TOPDIR/etc/internal/check-libtool-libs.pl $TOPDIR/lib

#
# Collect and make environment setting scripts etc/src.{c}sh
#
$PERL $TOPDIR/etc/internal/make-env.pl

#
# Generate etc/mailcap
#
$PERL $TOPDIR/etc/internal/make-mailcap.pl

# Generate Emacs Info info/dir file
$PERL $TOPDIR/etc/internal/make-emacs-dir.pl

#
# Generate emacs default and startup file
#
for dir in \
  $TOP/lib/emacs/site-lisp \
  $TOP/share/emacs/site-lisp
do
  $PERL $TOPDIR/etc/internal/make-emacs-default.pl $dir
done

for dir in \
  $TOP/lib/emacs/site-lisp \
  $TOP/share/emacs/site-lisp
do
  $PERL $TOPDIR/etc/internal/make-emacs-startup.pl $dir
done
