# This is a -*- perl -*- script, but it isn't directly runnable.
# Say "perl scriptname" instead.
#
# One-line description here.

$prefix='/store' ;

unshift( @INC, "$prefix/etc/internal" ) ;
unshift( @INC, "." ) ;

require "lib/client.pl" ;
require "lib/conffile.pl" ;
require "lib/config.pl" ;
require "lib/ficcl.pl" ;
require "lib/genarchs.pl" ;
require "lib/indata.pl" ;
require "lib/master.pl" ;
require "lib/output.pl" ;
require "lib/regist.pl" ;
require "lib/registerit.pl" ;
require "lib/runit.pl" ;
require "lib/shadowit.pl" ;
require "lib/slaveit.pl" ;
require "lib/support.pl" ;
require "lib/utils.pl" ;

&'readgenarchs ;
&'readconffile("$config") ;

$'myself = &mymachine() ;

$'debug = $'WARNINGS | $'INFO ;
$'debug = $'WARNINGS | $'INFO | $'TRACE if (-t) ;

# Setup finished

require "usage.pl" ;

$err = 0 ;
$donetop = $doneapp = $donever = $donest = $optx = $doforce = $dumpit = 0 ;
undef @wantstores ;
undef %wantstores ;
undef $wanttop ;

# parse options

while ( $_ = $ARGV[0] ) {
   shift;
   $err=1, last if /^-../ ;
   if (/^-a/)  { $wantapp = shift; $doneapp = 1; next ; }
   if (/^-t/)  { $wanttop = shift ; $donetop = 1 ; next ; }
   if (/^-v/)  { $donever = 1 ; next ; }
   if (/^-d/)  { $dumpit = 1 ; next ; }
   if (/^-f/)  { $doforce = 1 ; next ; }
   if (/^-X/)  { $optx = 1; next ; }
   if (/^-/)  { $err = 1; last ; }
   &'output('Error',"store $_ specified multiple times on command line\n"),$err=1,last 
    if ( $wantstores{$_} );
   push(@wantstores, $_ );
   $wantstores{$_}=1;
}

if ( $err ) {
    print "Usage: perl showusage.pl [-X] [-v] [ -t top ] [-a appl [-f]] \n";
    exit 1;
}

# Fill in list of default stores unless we have specified some.
unless ( @wantstores ) {
    $wanttop= $'linktop unless defined $wanttop ;
    for ( sort keys %isaknownstore ) {
	push(@wantstores, $_ ) 
	    if ( $wanttop eq $'logdir{'store',$_} &&
		$'isaknownstore{$_} eq 'internal'  &&
		-d $'storedir{$_} );
    }
}

# Check list of stores. 
for ( @wantstores ) {
  &'output('Error',"Unknown store $_\n"),$err=1,next
      unless ( $'isaknownstore{$_} );
  $wanttop = $'logdir{'store',$_} unless ( defined $wanttop );
  &'output('Error',"Bad top $'logdir{store,$_}, expected $wanttop\n"),$err=1,next 
      unless ( $wanttop eq $'logdir{'store',$_} );
}
exit 1 if ( $err );
    
# Check given top.

unless ( defined $'storetop{$wanttop} ) {
    &output('Fatal',"Bad top $wanttop\n");
    exit 1;
}


for $sto ( @wantstores ) {
    @usage = &usage'getinfo($sto, $wantapp, $doforce );
    if ( $dumpit ) {
	for ( @usage ) {
	    print "$_\n";
	}
	next;
    }
    for ( @usage ) {
	if ( m/^(.*)\@(.*) ([^ ]*) ([^ ]*) ([^ ]*) ([^ ]*) (.*)$/ ) {
	    $app = $1;
	    $store= $2;
	    $ver = $3;
	    $support = $4;
	    $links = $5 ;
	    $files = $6;
	    $size = $7;
	    $app =~ s=^\.== ;		# Dont differ between slaves and masters.
	    if ( $store ne $sto ) {
		&'output('Error',
		       "Expected store $sto, not $store\n");
		exit 1;
	    }
	    $map{$app,$store} +=$size;
	    $vmap{$app,$store,$ver}+=$size;
	    unless ( $appvmap{$app,$ver} ) {
		$appvmap{$app,$ver}++;
		$appmap{$app} .= '/' . $ver ;
	    }
	} else {
	    print STDERR "Bad line: $_\n";
	}
    }
}
exit 0 if ( $dumpit );
#
# Calculate sizes for presentation.
#
# First Initialize with minimal values. Then increase if 
# needed.
#
$appnamelen = 9; # App/Store
$vernamelen = 7; # Version
$sizelen = 4;
while ( ( $app, $junk ) = each %appmap ) {
    $appnamelen=length($app) if ( length($app) > $appnamelen ) ;
    if ( $donever ) {
	for $ver ( split('/', $appmap{$app} ) ) {
	    $vernamelen = length($ver) if ( length($ver) > $vernamelen );
	    unless ( $optx ) {
		for $store ( @wantstores ) {
		    $sizelen = length($vmap{$app,$store,$ver})
			if ( length($vmap{$app,$store,$ver}) > $sizelen );
		}
	    }
	}
    } else {
	unless ( $optx ) {
	    for $store ( @wantstores ) {
		$sizelen = length($map{$app,$store})
		    if ( length($map{$app,$store}) > $sizelen );
	    }
	}
    }
}

$sizelen2 = $sizelen ;
$numstores = 0;
for $store ( @wantstores ) {
    $sizelen2 = length($store) if ( length($store) > $sizelen2 );
    $numstores++;
}
$totlen = $appnamelen + 1 + ( 1 + $sizelen2 ) * $numstores ;
$totlen += $vernamelen +1 if ( $donever );
$pad = 0;
while ( $totlen + $pad * ( $numstores + 1 + $donever ) < 78 && $pad < 20 ) {
    $appnamelen++;
    $vernamelen++ if ( $donever );
    $sizelen2++;
    $sizelen++;
    $pad++;
}

$appformat =  "%-${appnamelen}s";
$verformat =  " %-${vernamelen}s";
$blankstring="                                                                         ";

$sizeformat = sprintf(" %%%dd%s",$sizelen2);
$storeformat = sprintf(" %%%ds",$sizelen2);
$leftxpad = substr($blankstring,0,$sizelen2-2);
$noxstring = $leftxpad . "   ";
$xstring = $leftxpad . "X  ";

printf $appformat, "App/Store";
if ( $donever ) { 
    printf $verformat, "Version";
}
for ( @wantstores ) {
 printf $storeformat, $_ ;
}
print "\n";

if ( $donever ) {
    for $app ( sort keys %appmap ) {
	for $ver ( sort split('/',$appmap{$app} ) ) {
	    next if ( $ver eq '' );
	    printf $appformat, $app ;
	    printf $verformat, $ver ;
	    for ( @wantstores ) {
		if ( $optx ) {
		    if ( $vmap{$app,$_,$ver} ) {
			print $xstring;
		    } else {
			print $noxstring;
		    }
		} else { 
		    printf $sizeformat, $vmap{$app,$_,$ver} ;
		}
	    }
	    print "\n";
	}
    }
} else {
    for $app ( sort keys %appmap ) {
	printf $appformat, $app ;
	for ( @wantstores ) {
	    if ( $optx ) {
		if ( $map{$app,$_} ) {
		    printf $xstring;
		} else {
		    printf $noxstring;
		}
	    } else { 
		printf $sizeformat, $map{$app,$_} ;
	    }
	}
	print "\n";
    }
}
