# This is a -*- perl -*- script, but it isn't directly runnable.
# Say "perl scriptname" instead.
#
# See vusage -h or under options here to see what this program do.

$prefix='/store' ;

unshift( @INC, "$prefix/etc/internal" ) ;
unshift( @INC, "." ) ;

require "lib/client.pl" ;
require "lib/conffile.pl" ;
require "lib/config.pl" ;
require "lib/ficcl.pl" ;
require "lib/genarchs.pl" ;
require "lib/indata.pl" ;
require "lib/master.pl" ;
require "lib/output.pl" ;
require "lib/regist.pl" ;
require "lib/registerit.pl" ;
require "lib/runit.pl" ;
require "lib/shadowit.pl" ;
require "lib/slaveit.pl" ;
require "lib/support.pl" ;
require "lib/utils.pl" ;

&'readgenarchs ;
&'readconffile("$config") ;

$'myself = &mymachine() ;

$'debug = $'WARNINGS | $'INFO ;
$'debug = $'WARNINGS | $'INFO | $'TRACE if (-t) ;

# Setup finished

require "usage.pl" ;

# $Id: vusage.pl,v 1.19 1996/11/08 04:00:43 arnej Exp $
# $Locker:  $

&Getopts("A:a:hl:g:rm:p:c:L:s:C:d:D:");

# Format of output
format stdout = 
@<<<<<<<<<<< @<<<<< @>>>>>> Kb
$appl,$ver,$kb
.

if ( ! $opt_l ) {$opt_l=9999999;}
if ( ! $opt_g ) {$opt_g= 0;}

# Get default master.
if ( $opt_m ) {
    $master = $opt_m;
}
else 
{
    chop( $cwd = `pwd` ) ;
    ( $ss, $aa, $vv ) = &whereami ;
    $master = &'simple("Which store",$ss);
}

# Check that master exists.

unless ( $'isaknownstore{$master} ) {
    &'output('Fatal',"No such store: '$master'\n",'Vusage','','','');
    exit 1;
}

unless ( -d "$'storedir{$master}" ) {
    &'output('Fatal',"No such dir: $'storedir{$master}\n",'Vusage',
	     $master,'','');
    exit 1;
}

$etc="$'storeadm/etc";
# $wantarch="sparc";				    # Default arch.
$domainfuzzyup=1;
$domainfuzzydown=1;
$archfuzzyup=1;
$archfuzzydown=1;
undef @wantarch;
undef @wantdomain;


if ( $opt_a ) { push(@wantarch,split(',',$opt_a));}
if ( $opt_A ) { push(@wantarch,split(',',$opt_A)); $archfuzzydown=0; }
if ( $opt_d ) { push(@wantdomain,split(',',$opt_d));}
if ( $opt_D ) { push(@wantdomain,split(',',$opt_D)); $domainfuzzydown= 0; }
if ( $opt_C ) { $opt_C =~ tr/[A-Z]/[a-z]/s; } # Convert string to lowercase.

# Check if legal type:
if ( $opt_L ) {&check_type("$etc/types.license" ,$opt_L,"license");}
if ( $opt_c ) {&check_type("$etc/types.program",$opt_c,"categories");}
if ( $opt_s ) {&check_type2("$etcdir/initials",$opt_s,"signatures");}

if ( @wantarch ) {&check_arch(@wantarch);}
if ( @wantdomain ) {&check_domain(@wantdomain);}

sub check_arch {
    local( @typename) = @_;
    local ( @possibles , $a );

    for ( @typename ) {
	next if ( $genarchs'knowngenarch{'arch',$_} );

	while ( ( $a , $junk ) = each %genarchs'knowngenarch ) {
	    next unless ( $a=~ m/arch$;(.*)/ );
	    push(@possibles,$1);
	}
	die "Possible architectures are:\n\n@possibles\n";
    }
}

sub check_domain {
    local( @typename) = @_;
    local ( @possibles , $a );

    for ( @typename ) {
	next if ( $genarchs'knowngenarch{'domain',$_} );

	while ( ( $a , $junk ) = each %genarchs'knowngenarch ) {
	    next unless ( $a=~ m/domain$;(.*)/ );
	    push(@possibles,$1);
	}
	die "Possible domains are:\n\n@possibles\n";
    }
}

sub check_type {
	 local($file,$typ,$typename)=@_;
	 undef $type_ok;
	 open(F,"$file") || die "$file";
	 while (<F>) {
		  ($id)=split;
		  if ($id eq $typ) {$type_ok=1;}
		  @types[$n++]="$_";
	 }
	 close(F);
	 if ( ! $type_ok ) { die "Possible $typename are:\n\n:@types\n"; }
}
sub check_type2 {
	 local($file,$typ,$typename)=@_;
	 undef $type_ok;
	 open(F,"$file") || die "$file";
	 while (<F>) {
		  ($junk,$id)=split;
		  if ($id eq $typ) {$type_ok=1;}
		  @types[$n++]="$_";
	 }
	 close(F);
	 if ( ! $type_ok ) { die "Possible $typename are:\n\n:@types\n"; }
}

# Help:
if ( $opt_h ) {
    print "\nThis program caclutates size of all used ver-* directories on the store-master.\n\n";
    print "Options:\n";
    print "  -h Help (you are looking at it now)\n";
    print "  -a <arch> (ie sparc,sun3 etc),  <arch> + allarch-files\n";
    print "  -A <arch> as -a, but without allarch-files\n";
    print "  -d <domain> (ie sparc,sun3 etc),  <domain> + alldomains-files\n";
    print "  -D <domain> as -a, but without alldomains-files\n";
    print "  -p <package> (or application...)\n";
    print "  -l <size> : all packages   less than <size> Kb\n";
    print "  -g <size> : all packages bigger than <size> Kb\n";
    print "  -c <category>\n";
    print "  -L <license-type>\n";
    print "  -s <signature>\n";
    print "  -C <substring in Comment\n";
    print "  -m master : check this master (it must be local or NFS-mounted)\n";
    print "  -r        : reversed sort\n";
    print "\nUsing both -l  and -g gives all pagages between these limits.\n";
    print "By adding `-' to options -a,-A,-c,-L and -s you get list of legal types,\nie -c- (or just use an nonlegal type)\n\n";

	 exit;
}
#

chdir("$'storedir{$master}");

################################################################
# Get the applications we want to find size for. 
# Creates an array,@appl_dirs, that has records with: appl.name:version
#
sub get_appl_dirs {
    local ( @usage ) ;
    
    &'output('Trace',"Getting applications\n", 'Vusage', $master );
    @usage = &usage'getinfo( $master, $opt_p, 0 );
    &'output('Trace',"Reading registry files\n", 'Vusage', $master );
    for ( @usage ) {
	if ( m/^(.*)\@(.*) ([^ ]*) ([^ ]*) ([^ ]*) ([^ ]*) (.*)$/ ) {
	    $app = $1;
	    $store= $2;
	    $ver = $3;
	    $support = $4;
	    $links = $5 ;
	    $files = $6;
	    $size = $7;
	    if ( @wantarch || @wantdomain ) {
		$usethis = 0;
		for ( split('/',$support ) ) {
		    if ( m=^arch:([^,]*),domain:([^,]*)(|,linktree:.*)$= ) {
			$arch = $1;
			$domain = $2;
			if ( @wantarch ) {
			    $archok=0;
			    for ( @wantarch ) {
				$archok=1,last 
				    if ( $_ eq $arch ||
					( $archfuzzydown &&
					 $genarchs'interval{'arch',$arch,'arch',$_} ) ||
					( $archfuzzyup &&
					 $genarchs'interval{'arch',$_,'arch',$arch} ) );
			    }
			} else {
			    $archok = 1;
			}
			if ( @wantdomain ) {
			    $domainok=0;
			    for ( @wantdomain ) {
				$domainok=1,last
				    if ( $_ eq $domain ||
					( $domainfuzzydown &&
					 $genarchs'interval{'domain',$domain,'domain',$_} ) ||
					( $domainfuzzyup &&
					 $genarchs'interval{'domain',$_,'domain',$domain} ) );
			    }
			} else {
			    $domainok=1;
			}
			$usethis=1,last if ( $archok && $domainok );
		    }
		}
	    } else {
		$usethis = 1;
	    }
	    unless ( defined $skipapp{$app} ) {
		if ( $opt_c || $opt_L || $opt_s || $opt_C ) {
		    if ( -d "$'storedir{$master}/$app" ) {
#			  &'output('Trace',"Reading registry file\n", 'Vusage', $master , $app);
			&'readregist( $master,$app ) ; 
			&'multi_version_parse() ;
			
			$skipapp{$app}=1 
			    if ( $opt_c && $'regist{'progtype'} ne $opt_c );
			$skipapp{$app}=1 
			    if ( $opt_L && $'regist{'licensetype'} ne $opt_L );
			$skipapp{$app}=1 
			    if ( $opt_s && $'regist{'signature'} ne $opt_s );
			if ( $opt_C ) {
			    $desc = $'regist{'descr'};
			    $desc =~ tr/[A-Z]/[a-z]/s;
			    $skipapp{$app}=1
				unless ( grep(/$opt_C/,"$desc") );
			}
			$skipapp{$app}=0 unless ( defined $skipapp{$app} );
		    } else {
			$skipapp{$app}=1;
		    }
		} else {
		    $skipapp{$app}=0;
		}
	    }
	    unless ( $skipapp{$app} ) {
		push(@appl_dirs, "$app:$ver" )
		    unless ( defined $appsize{$app,$ver} );
		$size=0 unless ( $usethis );
		$appsize{$app,$ver} += $size;
	    }
	}
    }
}

undef @appl_dirs;
&get_appl_dirs;
unless  ( defined @appl_dirs ) { die "No matching packages found\n";}

############################################################
# For every applications, get the size. The -l and -g options
# controls the size-limits for what appl. we want:
# 
# &'output('Trace',"Reading summary files\n", 'Vusage', $master );

$n = 0;
foreach (@appl_dirs) {
  ($dir,$ver)=split(":");	 
  ($appl=$dir) =~ s/^\.//g;
  $kb = $appsize{$dir,$ver} ;
  if ( $kb < $opt_l &&  $kb > $opt_g) {
      $sum=$sum+$kb;
      @appl_size[$n++]="$kb:$appl:$ver";
  }
}

# Sort applications by size. if -r revere sorting:
#
sub size_sort {if ( $opt_r ) {$b <=> $a;} else {$a <=> $b;}}
@appl_size=sort(size_sort @appl_size);


# Write it out
foreach (@appl_size) {
    ($kb,$appl,$ver)=split(":");
    $kb=int($kb+0.5);
    write;
}

# ..and finally give us the sum. If -p it will only be one line so we
# we don't need the 3 extra lines for the sum.
if ( ! $opt_p ) {
    $appl="SUM"; $kb=int($sum+0.5);
    print "------------------------------\n";
    write;
    print "==============================\n";
}

###############################################################

